package com.legalPersonMonitor.monitor;

import com.legalPersonMonitor.config.ParameterConfig;
import com.legalPersonMonitor.connections.HttpClientPool;
import com.legalPersonMonitor.data.*;
import com.legalPersonMonitor.utils.FormatBytesUtil;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;

import java.io.IOException;
import java.util.*;

/**
 * Created by gaoxiang on 2018/1/22.
 * 服务状态监控
 */
public class ServiceStateMonitoring {
    private static String msgDescription="";
    private static PreAuthResponseBean preAuthResponseBean;
    public static String serviceStateMonitoringServer(){
        try {
            String preAuthRespStr = HttpClientPool.postRequest("http://121.22.111.251:9002/legalPerson/v2.0/auth_app", ParameterConfig.PREAUTH_JSONSTR);
            JSONObject preAuthApply = JSONObject.fromObject(preAuthRespStr);
            preAuthResponseBean = (PreAuthResponseBean) JSONObject.toBean(preAuthApply, PreAuthResponseBean.class);
            if (!preAuthResponseBean.getSuccess()) {
                msgDescription = preAuthResponseBean.getErrorDesc();
            }
            JSONObject jsonObject = JSONObject.fromObject(ParameterConfig.AUTH_JSONSTR);
            Map config = new HashMap();
            config.put("authApplyRetainData", AuthApplyRetainBean.class);
            AuthRequestBean authRequestBean= (AuthRequestBean) JSONObject.toBean(jsonObject, AuthRequestBean.class, config);
            authRequestBean.setBusinessSerialNumber(preAuthResponseBean.getBusinessSerialNumber());
            String authResStr=JSONObject.fromObject(authRequestBean).toString();
            String authRespStr = HttpClientPool.postRequest("http://121.22.111.251:9002/legalPerson/v2.0/authen_req",authResStr);
            JSONObject authApply = JSONObject.fromObject(authRespStr);
            AuthResponseBean authResponseBean= (AuthResponseBean) JSONObject.toBean(authApply, AuthResponseBean.class);
            if(!authResponseBean.getSuccess()){
                msgDescription=authResponseBean.getErrorDesc();
            }
            msgDescription=authResponseBean.getAuthResult();
        }catch (Exception e){
            msgDescription="法人代理监控超时错误";
        }
        return msgDescription;

    }

    /**
     * 正确率查询
     */
    public static String correctRateQuery(String startTime,String endTime){

        String correctRateQueryStr="";
        try {
            correctRateQueryStr= HttpClientPool.getRequest("http://121.22.111.251:9002/legalPerson/v1.0/authSucStats?startTime="+startTime+"&endTime="+endTime+"&customerNumber=gtyx01");
        } catch (IOException e) {
            e.printStackTrace();
        }
        JSONObject correctRateQueryStrJson = JSONObject.fromObject(correctRateQueryStr);
        String str="法人代理在"+ FormatBytesUtil.stampToDate(startTime)+"时 至"+FormatBytesUtil.stampToDate(endTime)+"时 时间段内认证认证成功率是"+correctRateQueryStrJson.get("correctRate");
        return str;
    }
    public static String authCount(String startTime,String endTime){
        String authCountStr="";
        try {
            authCountStr= HttpClientPool.getRequest("http://121.22.111.251:9002/legalPerson/v1.0/authQtyStats?startTime="+startTime+"&endTime="+endTime+"&customerNumber=gtyx01");
        } catch (IOException e) {
            e.printStackTrace();
        }
        JSONObject correctRateQueryStrJson = JSONObject.fromObject(authCountStr);
        String str="法人代理在"+ FormatBytesUtil.stampToDate(startTime)+"时 至"+FormatBytesUtil.stampToDate(endTime)+"时 时间段内认证总计"+correctRateQueryStrJson.get("quantity")+"次";

        return str;
    }
    public static String authFrequency(String startTime,String endTime){
        String authFrequencyStr="";
        JSONArray authFrequencyList=null;
        String str="法人代理在";
        String key="";
        String value="";
        int i=1;
        try {
            authFrequencyStr= HttpClientPool.getRequest("http://121.22.111.251:9003/legalPerson/v1.0/authFreqStats?startTime="+startTime+"&endTime="+endTime+"&customerNumber=gtyx01&units=Hour");
            authFrequencyList = JSONArray.fromObject(authFrequencyStr);
            System.out.println(authFrequencyList);
        } catch (IOException e) {
            return "法人代理频次请求失败";
        }
        value= (JSONObject.fromObject(authFrequencyList.get(0)).get("count")).toString();
        if(authFrequencyList.size()==1&&value.equals("0")){
            str="<div>"+str+FormatBytesUtil.stampToDate(startTime)+"时至"+FormatBytesUtil.stampToDate(endTime)+"时 时间段内没有认证"+"</div>";
            return str;
        }
        if(authFrequencyList.size()==1){
            key = (JSONObject.fromObject(authFrequencyList.get(0)).get("time")).toString();
            str="<div>"+str+key+"时至"+ FormatBytesUtil.dateAddOneHour( key)+"时 时间段内认证"+value+"</div>";
            return str;
        }
        i=authFrequencyList.size();
        for(int j=0;j<authFrequencyList.size();j++){
            key = (JSONObject.fromObject(authFrequencyList.get(j)).get("time")).toString();
            value = (JSONObject.fromObject(authFrequencyList.get(j)).get("count")).toString();
            if(i==authFrequencyList.size()){
                str="<div>"+str+key+"时至"+FormatBytesUtil.dateAddOneHour( key)+"时 时间段内认证"+value+"次"+"</div>";
                i--;
            } else if (i!=1){
                str=str+"<div>在"+key+"时至"+FormatBytesUtil.dateAddOneHour(key)+"时 时间段内认证"+value+"次"+"</div>";
                i--;
            }else{
                str=str+"<div>在"+key+"时至"+FormatBytesUtil.dateAddOneHour(key)+"时 时间段内认证"+value+"次"+"</div>";
                break;
            }
        }
        return str;
    }
}
